/* Homework 2 Problem 3
 *
 * Copies switch pattern to LEDs only
 * when KEY3 changes from 0 to 1.
 *
 * Question: when KEY3 is not being pressed,
 * is it a 0 or a 1? How can you find out?
 *
 */

.include "ubc-de1media-macros.s"

.equ		KEY3mask,	0x08

.global	_start

.text
_start:		movia	r23, IOBASE

loop:

/* wait for KEY3 to go from 1 back to 0 */
/* without this wait, it behaves like a flow-through latch */
while1:		ldwio	r3, KEY(r23)
		andi	r3, r3, KEY3mask
		bne	r3, r0, while1	/* wait while KEY3=1 */

/* wait for KEY3 to go from 0 to 1 */
while0:		ldwio	r3, KEY(r23)
		andi	r3, r3, KEY3mask
		beq	r3, r0, while0	/* wait while KEY3=0 */

/* since KEY3 went from 0 to 1, copy switches to LEDs */
copy:		ldwio	r2, SWITCH(r23)
		stwio	r2, LEDR(r23)

		br	loop
.end
